
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class DependentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const dependents = await db.dependents.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        cpf: data.cpf
        ||
        null
            ,
            
        birth_date: data.birth_date
        ||
        null
            ,
            
        relationship_code: data.relationship_code
        ||
        null
            ,
            
        student: data.student
        ||
        false
        
            ,
            
        health_plan: data.health_plan
        ||
        false
        
            ,
            
        own_income: data.own_income
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await dependents.setDeclaration( data.declaration || null, {
            transaction,
        });
        
        await dependents.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return dependents;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const dependentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                cpf: item.cpf
            ||
            null
            ,
            
                birth_date: item.birth_date
            ||
            null
            ,
            
                relationship_code: item.relationship_code
            ||
            null
            ,
            
                student: item.student
            ||
            false
        
            ,
            
                health_plan: item.health_plan
            ||
            false
        
            ,
            
                own_income: item.own_income
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const dependents = await db.dependents.bulkCreate(dependentsData, { transaction });

        // For each item created, replace relation files
        

        return dependents;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const dependents = await db.dependents.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.cpf !== undefined) updatePayload.cpf = data.cpf;
        
        
        if (data.birth_date !== undefined) updatePayload.birth_date = data.birth_date;
        
        
        if (data.relationship_code !== undefined) updatePayload.relationship_code = data.relationship_code;
        
        
        if (data.student !== undefined) updatePayload.student = data.student;
        
        
        if (data.health_plan !== undefined) updatePayload.health_plan = data.health_plan;
        
        
        if (data.own_income !== undefined) updatePayload.own_income = data.own_income;
        
        
        updatePayload.updatedById = currentUser.id;

        await dependents.update(updatePayload, {transaction});

        
        
        if (data.declaration !== undefined) {
            await dependents.setDeclaration(
              
              data.declaration,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await dependents.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return dependents;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const dependents = await db.dependents.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of dependents) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of dependents) {
                await record.destroy({transaction});
            }
        });


        return dependents;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const dependents = await db.dependents.findByPk(id, options);

        await dependents.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await dependents.destroy({
            transaction
        });

        return dependents;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const dependents = await db.dependents.findOne(
            { where },
            { transaction },
        );

        if (!dependents) {
            return dependents;
        }

        const output = dependents.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.deductible_payments_dependent = await dependents.getDeductible_payments_dependent({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.declaration = await dependents.getDeclaration({
            transaction
        });
        
        
        output.organizations = await dependents.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.declarations,
        as: 'declaration',
        
        where: filter.declaration ? {
          [Op.or]: [
            { id: { [Op.in]: filter.declaration.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.declaration.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'dependents',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.cpf) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'dependents',
                        'cpf',
                        filter.cpf,
                    ),
                };
            }
            
            if (filter.relationship_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'dependents',
                        'relationship_code',
                        filter.relationship_code,
                    ),
                };
            }
            

            
            

            
            if (filter.birth_dateRange) {
                const [start, end] = filter.birth_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    birth_date: {
                    ...where.birth_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    birth_date: {
                    ...where.birth_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.own_incomeRange) {
                const [start, end] = filter.own_incomeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    own_income: {
                    ...where.own_income,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    own_income: {
                    ...where.own_income,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.student) {
                where = {
                    ...where,
                student: filter.student,
            };
            }
            
            if (filter.health_plan) {
                where = {
                    ...where,
                health_plan: filter.health_plan,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.dependents.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'dependents',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.dependents.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

